#include <exception>
#include <iostream>

using namespace std;

class A {
public:
	A() { cout << "A()" << endl; }

	virtual void print() { cout << "A()" << endl; }

};

class B: public A {
public:
	B() : A() {cout << "B()" << endl; }

	virtual void print() { cout << "B()" << endl; }

};

class C: public A {
public:
	C() : A() {cout << "C()" << endl; }

	virtual void print() { cout << "C()" << endl; }

};


int main()
{
	A a; B b; C c;
	B *pb; C *pc;
	A *pa1, *pa2;

	pa1 = &b;
	pa2 = &c;

	pb = dynamic_cast<B *>(pa1);
	pc = dynamic_cast<C *>(pa1); 

	cout << "pb = " << pb << "   pc = " << pc << endl;

	try {
		B &rb = dynamic_cast<B&>(*pa1);
		rb.print();
		B &rb2 = dynamic_cast<B&>(*pa2);
		rb2.print();
	} catch (bad_cast &e) {
		cout << "bad cast!! " << endl;
	}

}
