#include <string>

using namespace std;

class StackError {
  int errortype;
public:
  StackError(int et) : errortype(et) {}
  virtual string what() = 0;
  int getErrorType() { return errortype; }
};

class OutOfRange : public StackError {
public:
  OutOfRange() : StackError(0) {}
  virtual string what() { return "Index out of range" ;}
};

class EmptyStack : public StackError {
public: 
	EmptyStack() : StackError(1) {}
	virtual string what() { return "Empty Stack"; }
};

class Stack {
  class Elem {
  public:
    int data_;
    Elem *next_;
    Elem(int d, Elem *n);
  };

 public:

  Stack();
  ~Stack();

  void push(int a);
  int pop();

  int size();

  int operator[](int idx) throw(OutOfRange);

 private:
  Elem *head_;
  int size_;
};
